unit Spread;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, ExtCtrls, VBXCtrl, Vtss, VTSSInc, Menus,
  StdCtrls;

type
  TSpreadSheet = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    SSheetPanel: TPanel;
    CellMenu: TPopupMenu;
    Delete1: TMenuItem;
    Copy1: TMenuItem;
    Cut1: TMenuItem;
    Paste1: TMenuItem;
    N1: TMenuItem;
    Font1: TMenuItem;
    Border1: TMenuItem;
    aLIGNMENT1: TMenuItem;
    MainMenu1: TMainMenu;
    Format1: TMenuItem;
    Edit1: TMenuItem;
    Insert1: TMenuItem;
    PageBreak1: TMenuItem;
    N2: TMenuItem;
    Copy2: TMenuItem;
    Cut2: TMenuItem;
    Font2: TMenuItem;
    Border2: TMenuItem;
    Remove1: TMenuItem;
    PageBreak2: TMenuItem;
    Sheet1: TSheet;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    N3: TMenuItem;
    Print1: TMenuItem;
    PrintSetup1: TMenuItem;
    N4: TMenuItem;
    Exit1: TMenuItem;
    OpenDialog: TOpenDialog;
    N5: TMenuItem;
    Cell1: TMenuItem;
    Currency1: TMenuItem;
    Fraction1: TMenuItem;
    General1: TMenuItem;
    Fixed1: TMenuItem;
    DateTime1: TMenuItem;
    Date1: TMenuItem;
    Custom1: TMenuItem;
    SSEdit1: TSSEdit;
    Label1: TLabel;
    Pattern1: TMenuItem;
    Percent1: TMenuItem;
    GridLines: TMenuItem;
    ColumnWidth1: TMenuItem;
    ColumnWidth2: TMenuItem;
    N6: TMenuItem;
    ColumnPageBreak1: TMenuItem;
    RowPageBreak1: TMenuItem;
    Copy3: TMenuItem;
    Cut3: TMenuItem;
    Paste2: TMenuItem;
    Delete2: TMenuItem;
    N7: TMenuItem;
    Alignment2: TMenuItem;
    Ranges1: TMenuItem;
    RangeNames1: TMenuItem;
    GotoRange1: TMenuItem;
    N9: TMenuItem;
    Sort1: TMenuItem;
    N10: TMenuItem;
    PageSetup1: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    butPaste: TSpeedButton;
    butCopy: TSpeedButton;
    butCut: TSpeedButton;
    butPrint: TSpeedButton;
    butNew: TSpeedButton;
    butOpen: TSpeedButton;
    butSave: TSpeedButton;
    SaveDialog: TSaveDialog;
    procedure SSheetPanelResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Border1Click(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure aLIGNMENT1Click(Sender: TObject);
    procedure PageBreak1Click(Sender: TObject);
    procedure PageBreak2Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Currency1Click(Sender: TObject);
    procedure Fraction1Click(Sender: TObject);
    procedure General1Click(Sender: TObject);
    procedure Fixed1Click(Sender: TObject);
    procedure DateTime1Click(Sender: TObject);
    procedure Date1Click(Sender: TObject);
    procedure Custom1Click(Sender: TObject);
    procedure Pattern1Click(Sender: TObject);
    procedure Percent1Click(Sender: TObject);
    procedure GridLinesClick(Sender: TObject);
    procedure ColumnWidth1Click(Sender: TObject);
    procedure ColumnWidth2Click(Sender: TObject);
    procedure Panel2Resize(Sender: TObject);
    procedure PrintSetup1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure ColumnPageBreak1Click(Sender: TObject);
    procedure RowPageBreak1Click(Sender: TObject);
    procedure Alignment2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure butPasteClick(Sender: TObject);
    procedure RangeNames1Click(Sender: TObject);
    procedure GotoRange1Click(Sender: TObject);
    procedure Sort1Click(Sender: TObject);
    procedure PageSetup1Click(Sender: TObject);
    procedure butCopyClick(Sender: TObject);
    procedure butCutClick(Sender: TObject);
    procedure Sheet1KeyUp(Sender: TObject; var KeyCode, Shift: Integer);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure Sheet1EndRecalc(Sender: TObject);
    procedure butNewClick(Sender: TObject);
  private

  Sheet1Control : CSS ;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SpreadSheet: TSpreadSheet;
  gFileName : String;

implementation

{$R *.DFM}

procedure TSpreadSheet.SSheetPanelResize(Sender: TObject);
begin
Sheet1.Top := 0;
Sheet1.Left := 0;
Sheet1.Width := SSheetPanel.Width;
Sheet1.Height := SSheetPanel.Height;
end;

procedure TSpreadSheet.FormCreate(Sender: TObject);

var
CanPaste : Boolean;

begin
Sheet1Control := CSS.Create(Sheet1);
Sheet1.Top := 0;
Sheet1.Left := 0;
Sheet1.Width := SSheetPanel.Width;
Sheet1.Height := SSheetPanel.Height;
Sheet1Control.SetColWidth(1,256,(9*256),false);
Sheet1Control.SetRowHeight(1,16384,(1*256),false);
gFileName := 'NONE';
{SSEdit1.Width := Panel2.Width - 244;}
Sheet1Control.SetAppName('Spreadsheet Module');

Sheet1Control.CanEditPaste(CanPaste);
if CanPaste then begin
   Paste1.Enabled := True;
   Paste2.Enabled := True;
end;

end;

procedure TSpreadSheet.Border1Click(Sender: TObject);
begin
Sheet1Control.FormatBorderDlg;
end;

procedure TSpreadSheet.Font1Click(Sender: TObject);
begin
Sheet1Control.FormatFontDlg;
end;

procedure TSpreadSheet.aLIGNMENT1Click(Sender: TObject);
begin
Sheet1Control.FormatAlignmentDlg;
end;

procedure TSpreadSheet.PageBreak1Click(Sender: TObject);
begin
Sheet1Control.AddPageBreak
end;

procedure TSpreadSheet.PageBreak2Click(Sender: TObject);
begin
Sheet1Control.RemovePageBreak;
end;

procedure TSpreadSheet.Open1Click(Sender: TObject);

var FileType : Integer;
    FileExtension : String;
begin

FileType := 2;
OpenDialog.Execute;
if OpenDialog.FileName <> '' then begin
   FileExtension := ExtractFileExt(OpenDialog.FileName);
   if FileExtension = '.TXT' then FileType := 1;
   if FileExtension = '.XLS' then FileType := 2;
   if FileExtension = '.VTS' then FileType := 1;
   FileType := OpenDialog.FilterIndex;
   Sheet1Control.Read(OpenDialog.FileName,FileType);
   Self.Caption := 'Spreadsheet - ['+OpenDialog.FileName+']';
   gFileName := OpenDialog.FileName;
end;
end;
procedure TSpreadSheet.SaveAs1Click(Sender: TObject);
var FileName : String;
    FileType : Integer;
    Temp : Integer;
    SSError : Integer;
    FileExtension : String;
begin

   SaveDialog.Execute;
   if SaveDialog.FileName = '' then exit;
   gFileName := SaveDialog.FileName;

   FileExtension := ExtractFileExt(gFileName);
   FileType := 0;
   if FileExtension = '.TXT' then FileType := 1;
   if FileExtension = '.XLS' then FileType := 2;
   if FileExtension = '.VTS' then FileType := 1;

   if FileType = 0 then begin
      Temp := Application.MessageBox('You can only save files as either Spreadsheet format or Excel v4.0 compatible files.',
           'File Type Error', mb_OK + mb_ICONSTOP);
      exit;
      end;


if gFileName <> '' then begin
   Sheet1Control.Write(gFileName,FileType);
   Caption := 'Psec Spreadsheet - ['+gFileName+']';
end;
end;

procedure TSpreadSheet.Save1Click(Sender: TObject);

var FileType : Integer;
    FileExtension : String;
    Temp : Integer;

begin
if gFileName = 'NONE' then
   SaveAs1Click(Self)
else
begin
   FileExtension := ExtractFileExt(gFileName);
   FileType := 0;
   if FileExtension = '.TXT' then FileType := 1;
   if FileExtension = '.XLS' then FileType := 2;
   if FileExtension = '.VTS' then FileType := 1;

   Sheet1Control.Write(gFileName,FileType);
end;

end;

procedure TSpreadSheet.Currency1Click(Sender: TObject);
begin
Sheet1Control.FormatCurrency2;
end;

procedure TSpreadSheet.Fraction1Click(Sender: TObject);
begin
Sheet1Control.FormatFraction;
end;

procedure TSpreadSheet.General1Click(Sender: TObject);
begin
Sheet1Control.FormatGeneral;
end;

procedure TSpreadSheet.Fixed1Click(Sender: TObject);
begin
Sheet1Control.FormatFixed2;
end;

procedure TSpreadSheet.DateTime1Click(Sender: TObject);
begin
Sheet1Control.FormatHmmampm;
end;

procedure TSpreadSheet.Date1Click(Sender: TObject);
begin
Sheet1Control.FormatMdYy;
end;

procedure TSpreadSheet.Custom1Click(Sender: TObject);
begin
Sheet1Control.FormatNumberDlg;
end;

procedure TSpreadSheet.Pattern1Click(Sender: TObject);
begin
Sheet1Control.FormatPatternDlg;
end;

procedure TSpreadSheet.Percent1Click(Sender: TObject);
begin
Sheet1Control.FormatPerCent;
end;

procedure TSpreadSheet.GridLinesClick(Sender: TObject);
begin
GridLines.Checked := not  GridLines.Checked;
if GridLines.Checked then
   Sheet1Control.SetShowGridLines(True)
else
   Sheet1Control.SetShowGridLines(False)
end;

procedure TSpreadSheet.ColumnWidth1Click(Sender: TObject);
begin
Sheet1Control.RowHeightDlg;
end;

procedure TSpreadSheet.ColumnWidth2Click(Sender: TObject);
begin
Sheet1Control.ColWidthDlg;
end;

procedure TSpreadSheet.Panel2Resize(Sender: TObject);
begin
SSEdit1.Width := Panel2.Width - 244;
end;

procedure TSpreadSheet.PrintSetup1Click(Sender: TObject);
begin
Sheet1Control.FilePrintSetupDlg;

end;

procedure TSpreadSheet.Print1Click(Sender: TObject);

var ShowPrintDialog : Boolean;
    PrintArea : String;

begin
Sheet1Control.SetPrintAreaFromSelection;
Sheet1Control.FilePrint(ShowPrintDialog);
end;

procedure TSpreadSheet.ColumnPageBreak1Click(Sender: TObject);
begin
Sheet1Control.AddColPageBreak(Sheet1.Col) ;
end;

procedure TSpreadSheet.RowPageBreak1Click(Sender: TObject);
begin
Sheet1Control.AddRowPageBreak(Sheet1.Row);
end;

procedure TSpreadSheet.Alignment2Click(Sender: TObject);
begin
Sheet1Control.FormatAlignmentDlg;
end;

procedure TSpreadSheet.Button1Click(Sender: TObject);
var CanPaste : Boolean;

begin
end;

procedure TSpreadSheet.butPasteClick(Sender: TObject);
var CanPaste : Boolean;

begin
Sheet1Control.CanEditPaste(CanPaste);
if CanPaste then
   Sheet1Control.EditPaste;
end;

procedure TSpreadSheet.RangeNames1Click(Sender: TObject);
begin
Sheet1Control.DefinedNameDlg;
end;

procedure TSpreadSheet.GotoRange1Click(Sender: TObject);
begin
Sheet1Control.GotoDlg;
end;

procedure TSpreadSheet.Sort1Click(Sender: TObject);
begin
Sheet1Control.SortDlg;
end;

procedure TSpreadSheet.PageSetup1Click(Sender: TObject);
begin
Sheet1Control.FilePageSetupDlg;
end;

procedure TSpreadSheet.butCopyClick(Sender: TObject);
begin
Sheet1Control.EditCopy;
end;

procedure TSpreadSheet.butCutClick(Sender: TObject);
begin
Sheet1Control.EditCut;
end;

procedure TSpreadSheet.Sheet1KeyUp(Sender: TObject; var KeyCode,
  Shift: Integer);
Var StartCol,EndCol : Integer;
    StartRow,EndRow : Integer;

begin
if KeyCode = 46 then begin
   Sheet1Control.GetSelection(0,StartRow,StartCol,EndRow,EndCol);
   Sheet1Control.ClearRange(StartRow,StartCol,EndRow,EndCol,0);
end;


end;

procedure TSpreadSheet.Cut1Click(Sender: TObject);
begin
Sheet1Control.EditCut;
end;

procedure TSpreadSheet.Copy1Click(Sender: TObject);
begin
Sheet1Control.EditCopy;
end;

procedure TSpreadSheet.Paste1Click(Sender: TObject);
begin
Sheet1Control.EditPaste;
end;

procedure TSpreadSheet.Delete1Click(Sender: TObject);

Var StartCol,EndCol : Integer;
    StartRow,EndRow : Integer;

begin
   Sheet1Control.GetSelection(0,StartRow,StartCol,EndRow,EndCol);
   Sheet1Control.ClearRange(StartRow,StartCol,EndRow,EndCol,0);
end;

procedure TSpreadSheet.N11Click(Sender: TObject);
begin
Sheet1Control.CalculationDlg;
end;

procedure TSpreadSheet.Sheet1EndRecalc(Sender: TObject);

var CanPaste : Boolean;

begin
Sheet1Control.CanEditPaste(CanPaste);
if CanPaste then begin
   Paste1.Enabled := True;
   Paste2.Enabled := True;
end;
end;

procedure TSpreadSheet.butNewClick(Sender: TObject);

Var StartCol,EndCol : Integer;
    StartRow,EndRow : Integer;

begin

{ First,  get the last rows and columns.  Then,
  delete the contents of the selection }

   StartRow := 1;
   StartCol := 1;
   Sheet1Control.GetLastRow(EndRow);
   Sheet1Control.GetLastCol(EndCol);
   Sheet1Control.DeleteRange(StartRow,StartCol,EndRow,EndCol,1);

   { Reset the width and height of the cells to
     our default sizes }

   Sheet1Control.SetColWidth(1,256,(9*256),false);
   Sheet1Control.SetRowHeight(1,16384,(1*256),false);


   end;

end.
